// eff.cpp: implementation of the eff class.
//
//////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <memory.h>
#include <math.h>
#include <stdlib.h>
#include "ptc.h"
#include "eff.h"

extern unsigned char Vpismo[320*200];

#define max_x 319
#define max_y 199
#define min_x 0
#define min_y 0

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

eff::eff()
{
 m_framecnt=0;
}

void eff::genpal()
{
 // lock palette data
 int32 *data = palette.lock();
 // unlock palette
 palette.unlock();
}

void eff::setsurface(Surface* surface){
 mp_surface=surface;
 try{
  m_width=mp_surface->width();
  m_height=mp_surface->height();
  mp_pixels = (char8*)mp_surface->lock();
 }
 catch (Error &error)
 {
  // report error
  error.report();
 }
}

void eff::play(){
}

int eff::ESCkey(Console &ref_cons){
 Key key;

 if (ref_cons.key()){
  key=ref_cons.read();
  if (key.code()==Key::ESCAPE) return 1;
 }
 return 0;
} 

void eff::printspr(int s1x,int s1y, int s2x,int s2y,
              int dx,int dy,int col,char8* where)
{ 
  int ys,xs,xcnt=0,ycnt=0;
  
  for(ys=s1y;ys<=s2y;ys++)
  {
   for(xs=s1x;xs<=s2x;xs++)
    {
     if (Vpismo[xs+320*ys]==0)
      memset(where+dx+xcnt+(dy+ycnt)*320,col,1);
     xcnt++;    
    } 
   ycnt++,xcnt=0;
  }
}

Palette* eff::getpal(){
	return &palette;
}

//graphic functions
void eff::vPixScr(int X,int Y,char Color,char *where)
{
   char *px;
   px=(char *)(where+320*Y+X);
   *px=Color;
}

/*s tim jsem stravil pekne casu :-) */
void eff::DrawLine(int X1,int Y1,int X2,int Y2,char Color,char *Video)
{
        int Temp,i;
        float krokx=0.0,kroky=0.0;
        long inc=0;
        
        if(Y1>Y2) {     Temp=X1; X1=X2; X2=Temp;
                        Temp=Y1; Y1=Y2; Y2=Temp;        }
        if ((Y2<min_y) || (Y1>max_y)) return;
        if (Y1<min_y) 
           { X1+=(int)((0-Y1)*(X2-X1)/(float)(Y2-Y1));
             Y1=min_y;
            } 
        if (Y2>max_y) 
            { X2=(int)(X1+(max_y-Y1)*(X2-X1)/(float)(Y2-Y1));
              Y2=max_y;
            }
                    
        if (X1>X2)
         { if ((X1<min_x) || (X2>max_x)) return;        
           if (X1>max_x)
              { Y1+=(int)((max_x-X1)*(Y2-Y1)/(float)(X2-X1));
                X1=max_x;
               }  
           if (X2<min_x)
              {
               Y2=(int)(Y1+(min_x-X1)*(Y2-Y1)/(float)(X2-X1));
               X2=min_x;
              }  
         }

        if (X2>=X1)         /*rovnitko musi byt, aby pri souradnicich ,
                             ktere jsou mymo a jsou STEJNE se to spravne clipplo !!!!!!*/
         { if ((X1>max_x) || (X2<min_x)) return;
           if (X1<min_x)
             { Y1+=(int)((0-X1)*(Y2-Y1)/(float)(X2-X1));
               X1=min_x;
              }          
           if (X2>max_x)
             { Y2=(int)(Y1+(max_x-X1)*(Y2-Y1)/(float)(X2-X1));
               X2=max_x;
             }  
         }

        if ((abs(X2-X1))<(abs(Y2-Y1)))
         {
          if (Y2-Y1) inc=((X2-X1)<<16)/(Y2-Y1);    /*musi byt pred siftem X1, jinak chyba*/
          X1<<=16;
          for(i=Y1;i<(Y2+1);i++)
           { vPixScr(X1>>16,i,Color,Video);
             X1+=inc;
           }       
          return;
         }

        if ((abs(Y2-Y1))<(abs(X2-X1)))
         {
          if (X2<X1)  { Temp=X1; X1=X2; X2=Temp;
                        Temp=Y1; Y1=Y2; Y2=Temp;        }
          if (X2-X1) inc=((Y2-Y1)<<16)/(X2-X1);    /*musi byt pred siftem X1, jinak chyba*/
          Y1<<=16;
          for(i=X1;i<(X2+1);i++)
           { vPixScr(i,Y1>>16,Color,Video);
             Y1+=inc;
           }       
          return;
         }
}


void eff::gourhline(int x1,int x2, int c1,int c2,
               int y, char *where)
{
 int pom,i;
 long inccolh=0;
 long cintr;
 
  if (x1>x2)
   {
    pom=x1;
    x1=x2;
    x2=pom;
    pom=c1;
    c1=c2;
    c2=pom;
   }

  if (x2-x1) inccolh=((c2-c1)<<8)/(x2-x1);         //interpolacni krok
  if ((x2<min_x) || (x1>max_x)) return;
  if ((y>max_y) || (y<min_y)) return;
  if (x1<min_x)                            //clipping
   { if (x2-x1)
      { c1=((c1<<8)+(min_x-x1)*inccolh)>>8;
       x1=min_x;
      }
   }
  if (x2>max_x)  x2=max_x;
  cintr=c1<<8;
  for(i=x1;i<=x2;i++)
   {vPixScr(i,y,(char)(cintr>>8),where);
    cintr+=inccolh;
   }
  //ghline(x1,c1,x2,c2,y,where);
}

eff::~eff(){
}





