// eff2.cpp: implementation of the eff2 class.
//
//////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <memory.h>
#include <math.h>
#include <stdlib.h>
#include "ptc.h"
#include "3d1.h"
#include "eff2.h"

#define PI 3.1415192
#define Maxcol 160
#define Posuvx 160
#define Posuvy 100

//include  eff2::hvezda(object3d* objp)
#include "eff2hvezd.cpp"
//include  eff2::declare3(object3d* objp)
#include "eff2tvary.cpp"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

eff2::eff2()
{
 strcpy(m_name,"3D1");  
 m_framecnt=0;

 //setup for 3d rotation
 incz=1,pocet=0;   
 light.x=0;
 light.y=0;
 light.z=-1;
 fractik(5);
 cam.x=0;
 cam.y=0;
 cam.z=400;
 declare3(&obj);         
 hvezda(&obj2);
 sincosini();
 Ginitnorm(&obj2,&light,&lightn);
 Ginitnorm(&obj,&light,&lightn);
}

void eff2::genpal(){
  int RED=152,GREEN=300,BLUE=200;
  int j;

  int32 *data = palette.lock();

  for(j=255;j>0;j--)
  {
    data[j]=pack((int32) (129+127*(-sin(j*PI/RED))),
                 (int32) (129+127*(-sin(j*PI/GREEN))),
                 (int32) (129+127*(-sin(j*PI/BLUE))));

  }
  data[1]=pack(255,255,255);
  // unlock palette
  palette.unlock();
}

void eff2::play(){
  int col;

    memcpy(mp_pixels,Fractal,64000);
    uppgradeobject(&obj);   
    uppgradeobject(&obj2);   
    Gzxyrout(&obj);
    Gzxyrout(&obj2);
    perspektive(&obj);
    perspektive(&obj2);
    Greadin(&obj);
    Gputpolys(&obj);
    Greadin(&obj2);
    Gputpolys(&obj2);
    if (m_framecnt>200 && m_framecnt<1500) printspr(168,22,215,35,220,20,1,mp_pixels);
    if (m_framecnt>500 && m_framecnt<1500) printspr(221,22,245,35,235,44,1,mp_pixels);
    if (m_framecnt>800 && m_framecnt<1500) printspr(252,22,295,35,220,64,1,mp_pixels);
    if ((m_framecnt%30)==0)  
     {pocet++;
      obj2.objpos.z-=incz;
      for(col=1;col<(obj.Nvertex+1);col++)
      {
       obj.orgvertexes[col].x+=(int)(obj.vertnorm[col].x*incz);
       obj.orgvertexes[col].y+=(int)(obj.vertnorm[col].y*incz);
       obj.orgvertexes[col].z+=(int)(obj.vertnorm[col].z*incz);
      }
      for(col=1;col<(obj2.Nvertex+1);col++)
      {
       obj2.orgvertexes[col].x+=(int)(obj2.vertnorm[col].x*2*incz);
       obj2.orgvertexes[col].y+=(int)(obj2.vertnorm[col].y*3*incz);
       obj2.orgvertexes[col].z+=(int)(obj2.vertnorm[col].z*incz);
      }
    }
    if (pocet==40) {
		incz*=(-1);
		pocet=0;
	}
	m_framecnt++;
}


void eff2::fractik(int cislofr)
{
 int x,y;
 unsigned int ulozc;

   for(x=0;x<320;x++)
    { for(y=0;y<199;y++)
     {switch(cislofr)
      { case 1:ulozc=130+(int)(120*cos(sqrt(200-y)*sin(sqrt(320-x))));
               break;   
        case 2:ulozc=130+(int)(120*sin(sqrt(x*y)*cos(x/30.0)));
               break;
        case 3:ulozc=130+(int)(120*cos(x*y/8.0));
               break;
        case 4:ulozc=130+(int)(120*sin(y/10.0)*cos(x/10.0));
                break;
        case 5:ulozc=130+(int)(120*cos(pow(x/(y+200.0)*10,2.0)) 
                             *sin(pow(y/(x+200.0)*10,2.0)));

      }
      vPixScr(x,y,ulozc,(char *)Fractal);
     }
    }   //endforx
}

void eff2::sincosini(){
 int i;
 for (i=0;i<361;i++)
  { sint[i]=(float)sin(i*PI/180);
    cost[i]=(float)cos(i*PI/180);
   }  
} 


void eff2::calcnormals(object3D *objp2,int cpolygon,float *nx,float *ny,float *nz)
{  int ux,vx,uy,vy,uz,vz;
   int i;
   
   i=cpolygon;
   ux=objp2->orgvertexes[objp2->polys[i].whichvertexes[2]].x-objp2->orgvertexes[objp2->polys[i].whichvertexes[1]].x;
   vx=objp2->orgvertexes[objp2->polys[i].whichvertexes[3]].x-objp2->orgvertexes[objp2->polys[i].whichvertexes[1]].x;
   uy=objp2->orgvertexes[objp2->polys[i].whichvertexes[2]].y-objp2->orgvertexes[objp2->polys[i].whichvertexes[1]].y;
   vy=objp2->orgvertexes[objp2->polys[i].whichvertexes[3]].y-objp2->orgvertexes[objp2->polys[i].whichvertexes[1]].y;
   uz=objp2->orgvertexes[objp2->polys[i].whichvertexes[2]].z-objp2->orgvertexes[objp2->polys[i].whichvertexes[1]].z;
   vz=objp2->orgvertexes[objp2->polys[i].whichvertexes[3]].z-objp2->orgvertexes[objp2->polys[i].whichvertexes[1]].z;
   *nx=(float)(uy*vz-uz*vy);     /*normala nenormalizovana*/
   *ny=(float)(uz*vx-ux*vz);
   *nz=(float)(ux*vy-uy*vx);
}


/*inicializuje normaly a pseudonormaly*/
void eff2::Ginitnorm(object3D *objp,Point3D *light_p,
               Point3Df *lightn_p) 
{
   float lightl;
   //int ux,vx,uy,vy,uz,vz;
   float pomnormx,pomnormy,pomnormz;
   float nnormx,nnormy,nnormz;  
   float lengthpn;  
   int i,i1,i2;  

   float cx,cy,cz; //pro pseudonormaly
   int cn;  
      
   cx=cy=cz=0.0;
   cn=0;


  /*velikost normaly a normalizace svetla*/

   lightl=(float)sqrt((light_p->x*light_p->x)+(light_p->y*light_p->y)+(light_p->z*light_p->z));
   lightn_p->x=light_p->x/lightl;
   lightn_p->y=light_p->y/lightl;
   lightn_p->z=light_p->z/lightl;
   
   for(i=1;i<(objp->Npolys+1);i++) 
   {
    calcnormals(objp,i,&pomnormx,&pomnormy,&pomnormz);
 /* stary zpusob  neplati
  ux=objp->orgvertexes[objp->polys[i].whichvertexes[2]].x-objp->orgvertexes[objp->polys[i].whichvertexes[1]].x;
  vx=objp->orgvertexes[objp->polys[i].whichvertexes[3]].x-objp->orgvertexes[objp->polys[i].whichvertexes[1]].x;
  uy=objp->orgvertexes[objp->polys[i].whichvertexes[2]].y-objp->orgvertexes[objp->polys[i].whichvertexes[1]].y;
  vy=objp->orgvertexes[objp->polys[i].whichvertexes[3]].y-objp->orgvertexes[objp->polys[i].whichvertexes[1]].y;
  uz=objp->orgvertexes[objp->polys[i].whichvertexes[2]].z-objp->orgvertexes[objp->polys[i].whichvertexes[1]].z;
  vz=objp->orgvertexes[objp->polys[i].whichvertexes[3]].z-objp->orgvertexes[objp->polys[i].whichvertexes[1]].z;
    pomnormx=(uy*vz-uz*vy);     
    pomnormy=(uz*vx-ux*vz);
    pomnormz=(ux*vy-uy*vx);
  */  
   /*delka nenormalizovane normaly*/

   lengthpn=(float)(sqrt(pomnormx*pomnormx+pomnormy*pomnormy+pomnormz*pomnormz));
   if (lengthpn==0.0) lengthpn=1.0;
    /*konecna uprava normaly polygonu*/
    nnormx=pomnormx/lengthpn;
    nnormy=pomnormy/lengthpn;
    nnormz=pomnormz/lengthpn;
    
    objp->polys[i].normal.x=nnormx;
    objp->polys[i].normal.y=nnormy;
    objp->polys[i].normal.z=nnormz;
   }  
   
    //vypocet pseudonormal pro kazdy vertex 
    for(i1=1;i1<=objp->Nvertex;i1++)
    {cx=0.0,cy=0.0,cz=0.0,cn=0;
     for(i2=1;i2<=objp->Npolys;i2++)
     {
      if ((objp->polys[i2].whichvertexes[1]==i1) ||
          (objp->polys[i2].whichvertexes[2]==i1) ||
          (objp->polys[i2].whichvertexes[3]==i1)) 
       {
        calcnormals(objp,i2,&pomnormx,&pomnormy,&pomnormz);
  /*    cx+=objp->polys[i2].normal.x;
        cy+=objp->polys[i2].normal.y;
        cz+=objp->polys[i2].normal.z;
     */
	cx+=pomnormx;
	cy+=pomnormy;
	cz+=pomnormz;
	cn++;
       }
    }
    if (cn) 
    { 
     cx/=cn;
     cy/=cn;
     cz/=cn;
     lengthpn=(float)sqrt(cx*cx+cy*cy+cz*cz);
     if (lengthpn==0.0) lengthpn=1;
     //pseudonormala v intervalu 0 1
     objp->vertnorm[i1].x=cx/lengthpn;
     objp->vertnorm[i1].y=cy/lengthpn;
     objp->vertnorm[i1].z=cz/lengthpn;
     //pseudonormala s upravou na barvu}
     objp->pseudonorm[i1].x=(cx/(lengthpn*lightl)*Maxcol);
     objp->pseudonorm[i1].y=(cy/(lengthpn*lightl)*Maxcol);
     objp->pseudonorm[i1].z=(cz/(lengthpn*lightl)*Maxcol);
     }
    else printf("chyba ve vypoctu pseudonormal\n");
   } 
}

void eff2::uppgradeobject(object3D *objp)
{
  objp->degre.x+=objp->degreinc.x;
  objp->degre.y+=objp->degreinc.y;
  objp->degre.z+=objp->degreinc.z;
  if (objp->degre.x<0) objp->degre.x+=360;
  if (objp->degre.x>360) objp->degre.x-=360;
  if (objp->degre.y<0) objp->degre.y+=360;
  if (objp->degre.y>360) objp->degre.y-=360;
  if (objp->degre.z<0) objp->degre.z+=360;
  if (objp->degre.z>360) objp->degre.z-=360;
}


void eff2::perspektive(object3D *objp)
{
 int i;
  for(i=1;i<(objp->Nvertex+1);i++)
   { 
    objp->scrpoints[i].x=(int)(Posuvx+(((objp->rotvertexes[i].x)*256)/(objp->rotvertexes[i].z+cam.z)));
    objp->scrpoints[i].y=(int)(Posuvy+(((-(objp)->rotvertexes[i].y)*256)/(objp->rotvertexes[i].z+cam.z)));
   }  
}

//stejny jako zxyrout ,jen vypustena rotace normal a 
//pridacna rotace  pseudonormal
void eff2::Gzxyrout(object3D *objp)
{
 float a,b,c,d,e,f,g,h,j;
 int   i;
  /*priprava promenych*/  
  a=cost[objp->degre.y]*cost[objp->degre.z];
  b=cost[objp->degre.y]*sint[objp->degre.z];
  c=-sint[objp->degre.y];
  d=sint[objp->degre.x]*sint[objp->degre.y]*cost[objp->degre.z]-cost[objp->degre.x]*sint[objp->degre.z];
  e=sint[objp->degre.x]*sint[objp->degre.y]*sint[objp->degre.z]+cost[objp->degre.x]*cost[objp->degre.z];
  f=sint[objp->degre.x]*cost[objp->degre.y];
  g=cost[objp->degre.x]*sint[objp->degre.y]*cost[objp->degre.z]+sint[objp->degre.x]*sint[objp->degre.z];
  h=cost[objp->degre.x]*sint[objp->degre.y]*sint[objp->degre.z]-sint[objp->degre.x]*cost[objp->degre.z];
  j=cost[objp->degre.x]*cost[objp->degre.y];
  
  /*rotace vertexu*/
  for(i=1;i<(objp->Nvertex+1);i++) 
    {
    objp->rotvertexes[i].x =( objp->objpos.x+objp->orgvertexes[i].x*a+objp->orgvertexes[i].y*b
    +objp->orgvertexes[i].z*c);
    objp->rotvertexes[i].y =( objp->objpos.y+objp->orgvertexes[i].x*d+objp->orgvertexes[i].y*e
    +objp->orgvertexes[i].z*f);
    objp->rotvertexes[i].z =( objp->objpos.z+objp->orgvertexes[i].x*g+objp->orgvertexes[i].y*h
    +objp->orgvertexes[i].z*j);
    
    //rotace pseudonormal
    
    objp->rotpseudo[i].x =(objp->pseudonorm[i].x*a+objp->pseudonorm[i].y*b
    +objp->pseudonorm[i].z*c);
    objp->rotpseudo[i].y =(objp->pseudonorm[i].x*d+objp->pseudonorm[i].y*e
    +objp->pseudonorm[i].z*f);
    objp->rotpseudo[i].z =(objp->pseudonorm[i].x*g+objp->pseudonorm[i].y*h
    +objp->pseudonorm[i].z*j);
    }   
}  


void eff2::Greadin(object3D *objp)
{
  int i,b;
  float a;
  int  col2;
  int  l1,l2,l3;
  long  poma,pomb,pomc,pomd;
  long nz;

  numshow=0;  /*pocet viditelnych polygonu*/

  for(i=1;i<(objp->Npolys+1);i++)
   {
    a=0;
    for(b=1;b<4;b++) 
      {
       a+=objp->rotvertexes[objp->polys[i].whichvertexes[b]].z;
       objp->polys[i].cornerpoints[b]=objp->scrpoints[objp->polys[i].whichvertexes[b]];
      }
    a/=3;          /*prumer z souradnic polygonu*/
    objp->polys[i].zposition=(int)a;

    /*hidden face remove*/
    
    l1=objp->polys[i].whichvertexes[1];
    l2=objp->polys[i].whichvertexes[2];
    l3=objp->polys[i].whichvertexes[3];
    poma=(objp->scrpoints[l1].y-objp->scrpoints[l2].y);
    pomb=(objp->scrpoints[l3].x-objp->scrpoints[l2].x);
    pomc=(objp->scrpoints[l1].x-objp->scrpoints[l2].x);
    pomd=(objp->scrpoints[l3].y-objp->scrpoints[l2].y);

    nz=poma*pomb-pomc*pomd;     /*napsano podle ELova tutorialu*/

    if(nz>0)                  /*dale pocitam jen pro viditelne - zvetseni rychlosi!!!*/
     {++numshow;
      //dulezite na druhou pozici sortlistu uloz prumer z souradnic
      //na prvni pozici cislo polygonu
      // jinak to nepude!

       objp->sortdata.sortlist[numshow][1]=objp->polys[i].zposition;
       objp->sortdata.sortlist[numshow][0]=i;
       
       //nastaveni barvy prislusnych tri vertexu fejsu
       // pro vertex l1
       col2=(int)(obj.rotpseudo[l1].x*lightn.x
            +obj.rotpseudo[l1].y*lightn.y
            +obj.rotpseudo[l1].z*lightn.z);
       if (col2<0) col2=0;
       if (col2>Maxcol) col2=Maxcol;
       objp->vertcol[l1]=col2+60;   //posun v palete
       //pro vertex l2
       col2=(int)(obj.rotpseudo[l2].x*lightn.x
            +obj.rotpseudo[l2].y*lightn.y
            +obj.rotpseudo[l2].z*lightn.z);
       if (col2<0) col2=0;
       if (col2>Maxcol) col2=Maxcol;
       objp->vertcol[l2]=col2+60;
       //pro vertex l3
       col2=(int)(obj.rotpseudo[l3].x*lightn.x
            +obj.rotpseudo[l3].y*lightn.y
            +obj.rotpseudo[l3].z*lightn.z);
       if (col2<0) col2=0;
       if (col2>Maxcol) col2=Maxcol;
       objp->vertcol[l3]=col2+60;

       objp->polys[i].hidden=2;        /*polygon je viditelny*/
      }
     else (objp->polys[i].hidden=1);     /*neni videt*/
   }
}

void eff2::qs(int odk,int dok,object3D *world)
{ 
 int i,j;
 int x;
 int q0,q1;
 
 i=odk;
 j=dok;
 x=world->sortdata.sortlist[(j+i)>>1][1];   /*pivot*/
 do {
     while((world->sortdata.sortlist[i][1])<x) i++;
     while(x<(world->sortdata.sortlist[j][1])) j--;
     
     if (i<=j) 
       {
        q0=world->sortdata.sortlist[i][0];
        q1=world->sortdata.sortlist[i][1];
        world->sortdata.sortlist[i][0]=world->sortdata.sortlist[j][0];
        world->sortdata.sortlist[i][1]=world->sortdata.sortlist[j][1];
        world->sortdata.sortlist[j][0]=q0;
        world->sortdata.sortlist[j][1]=q1;
        i++,j--;
        }       
     } while (i<j);
   if ( odk<j) qs(odk,j,world);
   if ( i<dok) qs(i,dok,world);
} 

void eff2::Gputpolys(object3D *objp)
{
 int i;
 int x1,x2,y1,y2,x3,y3;
 int col1,col2,col3;
 int cispol;
 int vert1,vert2,vert3;
 
 QUICKSORT(1,numshow,objp);
 for(i=numshow;i>=1;i--)
   {
    cispol=objp->sortdata.sortlist[i][0];   /*cislo setrideneho polygonu*/
    if (objp->polys[cispol].hidden==2)  /*je videt ci ne*/
     {
      vert1=objp->polys[cispol].whichvertexes[1];
      x1=objp->polys[cispol].cornerpoints[1].x;
      y1=objp->polys[cispol].cornerpoints[1].y;

      col1=objp->vertcol[vert1];
      
      vert2=objp->polys[cispol].whichvertexes[2];
      x2=objp->polys[cispol].cornerpoints[2].x;
      y2=objp->polys[cispol].cornerpoints[2].y;
      col2=objp->vertcol[vert2];

      vert3=objp->polys[cispol].whichvertexes[3];
      x3=objp->polys[cispol].cornerpoints[3].x;
      y3=objp->polys[cispol].cornerpoints[3].y;
      col3=objp->vertcol[vert3];
      
      Gourtriangle(x1,y1,x2,y2,x3,y3,col1,col2,col3,mp_pixels);
     }    
   }
}

void eff2::putWirepolys(object3D *objp,unsigned char barva)
{
 int i;
 int x1,x2,x3,y1,y2,y3;
 
 for(i=1;i<((objp->Npolys)+1);i++)
   {
      x1=objp->polys[i].cornerpoints[1].x;
      y1=objp->polys[i].cornerpoints[1].y;
      x2=objp->polys[i].cornerpoints[2].x;
      y2=objp->polys[i].cornerpoints[2].y;
      x3=objp->polys[i].cornerpoints[3].x;
      y3=objp->polys[i].cornerpoints[3].y;
      DrawLine(x1,y1,x2,y2,barva,(char*)mp_pixels);
      DrawLine(x2,y2,x3,y3,barva,(char*)mp_pixels);
      DrawLine(x1,y1,x3,y3,barva,(char*)mp_pixels);
     }    
}

//proc setridi polygony(jen ty viditelne, viz proc putpolys)
// podle prumerne  z souradnice  
void eff2::QUICKSORT(int odk,int dok,object3D *world)
{
 qs(odk,dok,world);
} 


void eff2::Gourtriangle(int x1,int y1,int x2,int y2,
                  int x3,int y3, int col1,int col2,
                  int col3,char8* where)
{
 int pom,i;                  
 long delt1,delt2,delt3;
 long deltc1,deltc2,deltc3;
 int x1intr,x2intr,c1intr,c2intr;
    
 if (y1>y2) 
  {pom=y1;
   y1=y2;
   y2=pom;
   pom=x1;
   x1=x2;
   x2=pom;
   pom=col1;
   col1=col2;
   col2=pom;
   }
 
 if (y1>y3) 
    {pom=y1;
     y1=y3;
     y3=pom;
     pom=x1;
     x1=x3;
     x3=pom;
     pom=col1;
     col1=col3;
     col3=pom;
     }
 
 if (y2>y3) 
    {pom=y2;
     y2=y3;
     y3=pom;
     pom=x2;
     x2=x3;
     x3=pom;
     pom=col2;
     col2=col3;
     col3=pom;
     }
 
 if (!(y2-y1)) delt1=0,deltc1=0;             //interpolace x a barvy podle y
  else 
   { delt1=((x2-x1)<<16)/(y2-y1);
     deltc1=((col2-col1)<<16)/(y2-y1);
    } 
 
 if (!(y3-y2)) delt2=0,deltc2=0;
  else 
  { delt2=((x3-x2)<<16)/(y3-y2);
    deltc2=((col3-col2)<<16)/(y3-y2);
   }  
 
 if (!(y3-y1)) delt3=0,deltc3=0;  
  else 
   {
    delt3=((x3-x1)<<16)/(y3-y1);
    deltc3=((col3-col1)<<16)/(y3-y1);
    }
 
 x1intr=x2intr=x1<<16;
 c1intr=c2intr=col1<<16;
 for(i=y1;i<(y2+1);i++)
  {
   gourhline(x1intr>>16,x2intr>>16,c1intr>>16,c2intr>>16,i,(char*)where);
   x1intr+=delt3;
   x2intr+=delt1;
   c1intr+=deltc3;
   c2intr+=deltc1;
   }
 
 x1intr-=delt3;
 x2intr=x2<<16;
 c1intr-=deltc3;
 c2intr=col2<<16;
 for(i=y2;i<(y3+1);i++)
  {
   gourhline(x1intr>>16,x2intr>>16,c1intr>>16,c2intr>>16,i,(char*)where);
   x1intr+=delt3;
   x2intr+=delt2;
   c1intr+=deltc3;
   c2intr+=deltc2;
   }
} 


eff2::~eff2()
{

}
