// eff4.cpp: implementation of the eff4 class.
//
//////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <memory.h>
#include <math.h>
#include <stdlib.h>
#include "ptc.h"
#include "3d1.h"
#include "eff4.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

eff4::eff4()
{
 strcpy(m_name,"Plasma");  
 m_framecnt=0;
 sx1=sx2=sy1=sy2=0; 
 //setup for 3d rotation
  pocet=0,incy=-5,cisl=1;
  light.x=0;
  light.y=0;
  light.z=-1;
  cam.x=0;
  cam.y=0;
  cam.z=400;
  sincosini();
  precalc(); //predpocitam sinus 
  hvezda(&obj2);
  Ginitnorm(&obj2,&light,&lightn);
  obj2.objpos.z=-270;
  obj2.degreinc.x=obj.degreinc.y=obj2.degreinc.z=3;
}

eff4::~eff4()
{

}

void eff4::genpal(){
  int         col;
  int         from,to;
  int         br,bg,bb,fr,fg,fb;
  int         er,eg,eb; 

  int32 *paldata = palette.lock();
 

  from=0,to=63;
  br=0,bg=0,bb=0,fr=41,fg=41,fb=41; 
  //set linear palette
  for(col=from;col<=to;col++)
   {
     er=br+((col-from)*(fr-br)/(to-from));
     eg=bg+((col-from)*(fg-bg)/(to-from));
     eb=bb+((col-from)*(fb-bb)/(to-from));
     paldata[col]=pack(er,eg,eb);
   } 
  from=64,to=127;
  br=41,bg=41,bb=41,fr=121,fg=121,fb=125; 
  //set linear palette
  for(col=from;col<=to;col++)
   {
     er=br+((col-from)*(fr-br)/(to-from));
     eg=bg+((col-from)*(fg-bg)/(to-from));
     eb=bb+((col-from)*(fb-bb)/(to-from));
     paldata[col]=pack(er,eg,eb);
   } 
  from=128,to=191;
  br=121,bg=121,bb=125,fr=85,fg=87,fb=255;
  //set linear palette
  for(col=from;col<=to;col++)
   {
     er=br+((col-from)*(fr-br)/(to-from));
     eg=bg+((col-from)*(fg-bg)/(to-from));
     eb=bb+((col-from)*(fb-bb)/(to-from));
     paldata[col]=pack(er,eg,eb);
   } 
  from=192,to=255;
  br=85,bg=87,bb=255,fr=0/63*255,fg=0/63*255,fb=0/63*255;
  //set linear palette
  for(col=from;col<=to;col++)
   {
     er=br+((col-from)*(fr-br)/(to-from));
     eg=bg+((col-from)*(fg-bg)/(to-from));
     eb=bb+((col-from)*(fb-bb)/(to-from));
     paldata[col]=pack(er,eg,eb);
  } 
  // unlock palette
  palette.unlock();
}


void eff4::play(){
    sx1+=3+incy;
    sx2-=5;
    sy1+=3;
    sy2+=3*incy;
    if((m_framecnt%20)==0) incy+=cisl,pocet++;
    if(pocet==10) cisl=(-1)*cisl,pocet=0; 
    plasmatic();
    //3D
    uppgradeobject(&obj2);   
    zxyrout(&obj2);
    perspektive(&obj2);
    Greadin(&obj2);
    putWirepolys(&obj2,121);
    //
    if (m_framecnt>100 && m_framecnt<790) printspr(1,52,64,69,20,20,128,mp_pixels);
    if (m_framecnt>210 && m_framecnt<550)
      {
       printspr(72,54,136,70,70,45,128,mp_pixels);
       printspr(129,54,148,68,70,70,128,mp_pixels);
      }
    if (m_framecnt>550 && m_framecnt<790)
     {
       printspr(149,54,213,68,70,45,128,mp_pixels);
       printspr(216,54,289,68,70,70,128,mp_pixels);
       printspr(1,75,47,84,148,74,128,mp_pixels);
       printspr(48,72,107,88,70,95,128,mp_pixels);
     }
    if (m_framecnt>790)
     {
       printspr(6,5,68,19,100,80,128,mp_pixels);
       printspr(120,22,163,35,190,81,128,mp_pixels);
     }
	m_framecnt++;
}


void eff4::precalc(void)
{
  int i;
  for(i=-128; i<129; i++)
    sin2t[i+128]=(int)(80*sin(abs(i)*PI/256));
}

void eff4::plasmatic(void)
{
  unsigned char px1, px2, py1, py2; //pomocne body
  int x, y;
  int barva;
   
  py1=sy1;
  py2=sy2;
  for(y=0; y<200; y++)
   {px1=sx1,px2=sx2;
    for(x=0; x<320; x++)
    {
     barva=sin2t[py1]+sin2t[py2]+sin2t[px1]+sin2t[px2];
     if (barva==255) barva=0; 
     vPixScr(x,y,barva,(char*)mp_pixels);
     px1+=1;
     px2+=1;
    }
    py1+=2;
    py2+=1;
  }
}

void eff4::zxyrout(object3D *objp)
{
 float a,b,c,d,e,f,g,h,j;
 int   i;
  /*priprava promenych*/  
  a=cost[objp->degre.y]*cost[objp->degre.z];
  b=cost[objp->degre.y]*sint[objp->degre.z];
  c=-sint[objp->degre.y];
  d=sint[objp->degre.x]*sint[objp->degre.y]*cost[objp->degre.z]-cost[objp->degre.x]*sint[objp->degre.z];
  e=sint[objp->degre.x]*sint[objp->degre.y]*sint[objp->degre.z]+cost[objp->degre.x]*cost[objp->degre.z];
  f=sint[objp->degre.x]*cost[objp->degre.y];
  g=cost[objp->degre.x]*sint[objp->degre.y]*cost[objp->degre.z]+sint[objp->degre.x]*sint[objp->degre.z];
  h=cost[objp->degre.x]*sint[objp->degre.y]*sint[objp->degre.z]-sint[objp->degre.x]*cost[objp->degre.z];
  j=cost[objp->degre.x]*cost[objp->degre.y];
  
  /*rotace vertexu*/
  for(i=1;i<(objp->Nvertex+1);i++) 
    {
    objp->rotvertexes[i].x =( objp->objpos.x+objp->orgvertexes[i].x*a+objp->orgvertexes[i].y*b
    +objp->orgvertexes[i].z*c);
    objp->rotvertexes[i].y =( objp->objpos.y+objp->orgvertexes[i].x*d+objp->orgvertexes[i].y*e
    +objp->orgvertexes[i].z*f);
    objp->rotvertexes[i].z =( objp->objpos.z+objp->orgvertexes[i].x*g+objp->orgvertexes[i].y*h
    +objp->orgvertexes[i].z*j);
    }   
  
  /*rotace normal*/
   for(i=1;i<(objp->Npolys+1);i++) 
   {
    objp->polys[i].rotnormal.x=(objp->polys[i].normal.x*a+objp->polys[i].normal.y*b
    +objp->polys[i].normal.z*c);
    objp->polys[i].rotnormal.y=(objp->polys[i].normal.x*d+objp->polys[i].normal.y*e
    +objp->polys[i].normal.z*f);
    objp->polys[i].rotnormal.z=(objp->polys[i].normal.x*g+objp->polys[i].normal.y*h
    +objp->polys[i].normal.z*j);
   }
}  
